<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.orderrefund_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/finance/orderrefund";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "退款ID",
              prop: "id",
              rules: [{
                required: true,
                message: "请输入退款ID",
                trigger: "blur"
              }]
            },
            {
              label: "订单ID",
              prop: "orderId",
              rules: [{
                required: true,
                message: "请输入订单ID",
                trigger: "blur"
              }]
            },
            {
              label: "用户ID",
              prop: "userId",
              rules: [{
                required: true,
                message: "请输入用户ID",
                trigger: "blur"
              }]
            },
            {
              label: "退款状态",
              prop: "refundState",
              rules: [{
                required: true,
                message: "请输入退款状态",
                trigger: "blur"
              }]
            },
            {
              label: "退款原因",
              prop: "reason",
              rules: [{
                required: true,
                message: "请输入退款原因",
                trigger: "blur"
              }]
            },
            {
              label: "退款凭证（图片）",
              prop: "rimgs",
              rules: [{
                required: true,
                message: "请输入退款凭证（图片）",
                trigger: "blur"
              }]
            },
            {
              label: "退款备注",
              prop: "remark",
              rules: [{
                required: true,
                message: "请输入退款备注",
                trigger: "blur"
              }]
            },
            {
              label: "拒绝原因",
              prop: "refuseReason",
              rules: [{
                required: true,
                message: "请输入拒绝原因",
                trigger: "blur"
              }]
            },
            {
              label: "退款类型  0--只退款，1--退货退款",
              prop: "refundType",
              rules: [{
                required: true,
                message: "请输入退款类型  0--只退款，1--退货退款",
                trigger: "blur"
              }]
            },
            {
              label: "退款物流公司",
              prop: "wlName",
              rules: [{
                required: true,
                message: "请输入退款物流公司",
                trigger: "blur"
              }]
            },
            {
              label: "物流单号",
              prop: "wlNum",
              rules: [{
                required: true,
                message: "请输入物流单号",
                trigger: "blur"
              }]
            },
            {
              label: "退款地址",
              prop: "shopAddress",
              rules: [{
                required: true,
                message: "请输入退款地址",
                trigger: "blur"
              }]
            },
            {
              label: "申请时间",
              prop: "createTime",
              rules: [{
                required: true,
                message: "请输入申请时间",
                trigger: "blur"
              }]
            },
            {
              label: "同意/拒绝时间",
              prop: "agreeTime",
              rules: [{
                required: true,
                message: "请输入同意/拒绝时间",
                trigger: "blur"
              }]
            },
            {
              label: "退款时间",
              prop: "refundTime",
              rules: [{
                required: true,
                message: "请输入退款时间",
                trigger: "blur"
              }]
            },
            {
              label: "删除标识   0正常  1逻辑删除",
              prop: "isDeleted",
              rules: [{
                required: true,
                message: "请输入删除标识   0正常  1逻辑删除",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.orderrefund_add, false),
          viewBtn: this.vaildData(this.permission.orderrefund_view, false),
          delBtn: this.vaildData(this.permission.orderrefund_delete, false),
          editBtn: this.vaildData(this.permission.orderrefund_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
